<?
/*
*******************************
 IP-SYMCON Event Scripting
*******************************
File     : AnswerMachine.ips.php
Trigger  : "ISDN_Status"
Interval :
Authors: original code by Schlimmerfinger, modified by Zapp (Call logging), 2006
*/

// ********** USER SETTINGS *******************************************
define("__myhome","");
// Path to Web log output (table include files and WAVs)
$myWebHome = IPS_GetKernelDir()."web\\calls";
// Path to Sound files
$soundFilePath = __myhome."\\Sounds\\Fritz\\";
$debug = false;

// ******** END OF USER SETTINGS *************************************

$weblogFilePath = $myWebHome;
$callLogFilePath = __myhome."\\Call.Logs\\call_log_".date("ymd").".txt";

// Number of "knocks"
$numberOfRings = GetValueInteger("ISDN_NumberOfRings");
// Are we already connected ? (avoids logging and answering twice)
$hasBeenConnected = GetValueBoolean("ISDN_IsConnected");

SetValueInteger("ISDN_NumberOfRings", $numberOfRings + 1);

$buffer = GetValueString("ISDN_Status");
if($buffer=="") {
   exit;
}

// Open the Call log file
if ($debug) $logHandle=fopen("$callLogFilePath", "a");

$items = explode(chr(13).chr(10), $buffer);
foreach($items as $item) {
   // SK: Datum und Zeit ermitteln
   $callTimeStamp = Date("H:i");
   $skDate = Date("Ymd");
   $skTime = Date("H-i-s");

   // wer hat angerufen?
   if (substr($item, 0, 13) == "CallingNumber"){           // nach "CallingNumber" suchen
      if ($debug) fwrite($logHandle, date("d.m.y")." - ".date("H:i:s")." -> Ring:".$numberOfRings." - FOUND NUMBER \r\n");
      $callerNumber = substr($item, 14, 20);                    // der Rest ist die Telefonnummer
      if ($callerNumber <> "") {
         $callerName = findNumberDB($callerNumber);
         if ($callerName === false) {  // Number not found in phonebook, search the web
            switch(substr($callerNumber,0,4)) {
               case "33":
                  echo "French number calling...\r\n";
                  // TODO
                  break;
               case "32":
                  echo "Belgian number calling...\r\n";
                  // TODO
                  break;
               case "43":
                  echo "Austrian number calling...\r\n";
                  // TODO
                  break;
               default:
                  echo "German number calling...\r\n";
                  if (substr($callerNumber,0,1) != "0") $callerNumber = "0".$callerNumber;
                  if ($numberOfRings == 1) { // Web lookup only performed once to avoid connection overflow
                     if ($debug) fwrite($logHandle, date("d.m.y")." - ".date("H:i:s")." -> Ring:".$numberOfRings." - RESOLVING NAME FROM WEB \r\n");
                     $callerName = findNumberDE($callerNumber);
                  } else {
                     $callerNameGlobal = GetValueString("PhoneNumber_Name");
                     if ($callerNameGlobal <> "") $callerName = $callerNameGlobal;
                  }
                  break;
            }
         } else {
            if ($debug) fwrite($logHandle, date("d.m.y")." - ".date("H:i:s")." -> Ring:".$numberOfRings." - FOUND NAME IN DB (".$callerName.")\r\n");
         }
      } else {
         $callerNumber = "Unknown";
         $callerName = "Unknown";
      }
      if (!isset($callerName) or ($callerName == "")) {
         $callerName = "Unknown";
      }
      // Keep the caller Name
      SetValueString("PhoneNumber_Name", $callerName);

   }  // End of "Wer hat angerufen ?"

   // hier wird der Status ausgewertet und der eigentliche AB gestartet
   if (($item == "Connected") and (!$hasBeenConnected)){
      $webLogFileName = "Message_from_".$callerNumber."_on_".$skDate."_".$skTime.".wav";
      $webLogFile = $weblogFilePath."\\".$webLogFileName;
      SetValueBoolean("ISDN_IsConnected", True);
      if ($debug) fwrite($logHandle, date("d.m.y")." - ".date("H:i:s")." -> Ring:".$numberOfRings." - CONNECTED \r\n");
      IPS_Sleep(4000);
      ISDN_PlayWave(14268, $soundFilePath."Ansage8k.wav");
      IPS_Sleep(7100);
      ISDN_PlayWave(14268, $soundFilePath."Aufnahme8k.wav");
      IPS_Sleep(1000);
      ISDN_RecordWave(14268, $webLogFile);

      // LOG TO KERNEL MESSAGES AND WEB PAGE
      IPS_LogMessage( "ISDN","Call from ".$callerName." (AM On)" );
      if ($debug) fwrite($logHandle, date("d.m.y")." - ".date("H:i:s")." -> Ring:".$numberOfRings." - WRITE WEB PAGE \r\n");
      // Write calls web page
      $WebLogHandle=fopen("$weblogFilePath\\callsLog_".$skDate.".php", "a");
      // Add a line to the calls table in calls.php
      // Write everything on one line to be able to delete the line if the user requires it
      fwrite($WebLogHandle, "<tr>");
      fwrite($WebLogHandle, "<td valign='top' bgcolor='#BBBBBB'>".$callTimeStamp."</td>");
      fwrite($WebLogHandle, "<td valign='top' bgcolor='#BBBBBB'>".$callerNumber."</td>");
      fwrite($WebLogHandle, "<td valign='top' bgcolor='#BBBBBB'>".$callerName."</td>");
      fwrite($WebLogHandle, "<td valign='top' bgcolor='#BBBBBB'><a href='./calls/".$webLogFileName."' title='Listen to the Message'>Yes</a></td>");
      fwrite($WebLogHandle, "</tr>");
      fclose($WebLogHandle);
   }  // end of if connnected
}  // end of foreach loop on $item

// Write to log file
if ($debug) fwrite($logHandle, date("d.m.y")." - ".date("H:i:s")." -> Ring:".$numberOfRings." - Number: ".$callerNumber." - Name: ".$callerName." - item: ".$item."\r\n");

// Auflegen erkennen und Aufnahme stoppen
$items = explode(chr(13).chr(10), $buffer);
foreach($items as $item) {

   if($item == "Disconnected") {
      if ($debug) fwrite($logHandle, date("d.m.y")." - ".date("H:i:s")." -> Ring:".$numberOfRings." - DISCONNECTED \r\n");
      ISDN_StopRecord(14269);
      SetValueBoolean("ISDN_IsConnected", False);

      //... und den Status-Buffer lschen
      SetValueString("ISDN_Status", "");
      SetValueInteger("ISDN_NumberOfRings", 0);

      // If it has not been connected, the AM is not On and we log the call here
      if (!$hasBeenConnected) {
         IPS_LogMessage( "ISDN","Call from ".$callerName." (AM Off)" );
         if ($debug) fwrite($logHandle, date("d.m.y")." - ".date("H:i:s")." -> Ring:".$numberOfRings." - WRITE WEB PAGE \r\n");
         // Write calls web page
         $WebLogHandle=fopen("$weblogFilePath\\callsLog_".$skDate.".php", "a");
         // Add a line to the calls table in calls.php
         // Write everything on one line to be able to delete the line if the user requires it
         fwrite($WebLogHandle, "<tr>");
         fwrite($WebLogHandle, "<td valign='top' bgcolor='#BBBBBB'>".$callTimeStamp."</td>");
         fwrite($WebLogHandle, "<td valign='top' bgcolor='#BBBBBB'>".$callerNumber."</td>");
         fwrite($WebLogHandle, "<td valign='top' bgcolor='#BBBBBB'>".$callerName."</td>");
         fwrite($WebLogHandle, "<td valign='top' bgcolor='#BBBBBB'>No</a></td>");
         fwrite($WebLogHandle, "</tr>");
         fclose($WebLogHandle);
      }

      if ($debug) fclose($logHandle);
      // clear the Phone Number
      SetValueString("PhoneNumber_Name", "");

      exit;
   }
}


function findNumberDE($callerNumber)
{
   $url_orig="http://www.dasoertliche.de/DB4Web/es/oetb2suche/home.htm?kw_invers=#TEL#&main=Antwort&s=2";
   $url=str_replace("#TEL#","$callerNumber",$url_orig);
   //$ch = curl_init("$url_orig");
   $handle=fopen("$url", "r");
   if (!$handle){
      // error cannot open file
      echo("ERROR : CANNOT OPEN URL : '$url'\r\n");
   }
   $lineNb = 0;
   $searchTag0 = '<a  class="blb" href="';
   $searchTag1 = '">';
   $searchTag2 = '<';
   while(!feof($handle)) {
      $lineNb++;
      $buffer = fgets($handle);
      if (strpos($buffer, $searchTag0) !== false) {
        echo "found a Name in line: ".$lineNb."\r\n";
        $foundName = strstr(strstr($buffer, $searchTag0), $searchTag1);
        $endPos = strpos($foundName, $searchTag2);
        $foundName1 = substr($foundName,strlen($searchTag1),$endPos - strlen($searchTag1));
        if (!isset($foundName1)) $foundName1 = "";
        echo "substr: ".$foundName1."\r\n";
      }
   }
   fclose($handle);
   return $foundName1;
}

function findNumberDB($callerNumber)
{
   $mysql_host="localhost";   // Host name
   $mysql_username="";        // Mysql username
   $mysql_password="";        // Mysql password
   $mysql_db_name="";         // Database name
   $mysql_tbl_name="";        // Table name

   // Current date
   $nowDate = date("y-m-d H:i:s");

   // Connect to server and select databse.
   $link = mysql_connect("$mysql_host", "$mysql_username", "$mysql_password")or die("cannot connect");
   mysql_select_db("$mysql_db_name")or die("cannot select DB");

   // Find an entry in the table with that number
   $sql="SELECT * FROM $mysql_tbl_name WHERE Number LIKE '%$callerNumber'";
   $result=mysql_query($sql);
   echo "sql query: ".$sql."\r\n";

   // Mysql_num_row is counting table row
   $count=mysql_num_rows($result);
   echo "entries found in book: ".$count."\r\n";

   if ($count == 1) {
      $row = mysql_fetch_object($result);
      echo "Name: ".$row->Name." (".$row->Type.")\r\n";
      return "$row->Name"." ($row->Type)";
   } elseif ($count > 1) {
      echo "Various Names\r\n";
      return "Various Names";
   } else {
      echo "No Name Found\r\n";
      return false;
   }
}
?>
